/**
 * @see https://umijs.org/docs/max/access#access
 * */
export default function access(initialState: { menuType: "distributor" | "miniApp", selectApp: { id: number }, currentUser: { manageAccount: boolean } }) {
  return {
    isShow: (route: { name: string; }) => {
      if (initialState?.menuType) {
        const { menuType, currentUser } = initialState;
        let regex = new RegExp(`^${menuType}\\.`);
        if (route.name.match(/(distributor.appManage)|(distributor.account)|(distributor.corpManage)/ig)) {
          return currentUser?.manageAccount && route.name.match(regex)
        }
        return route.name.match(regex)
      }
      return false
    },//路由名称包含menuType才显示
  };
}
