import { PageContainer, ProTable } from "@ant-design/pro-components"
import { Table } from "antd"
import { columns, childrenColumns } from "./tableConfig"
import { useAjax } from "@/Hook/useAjax"
import { useMemo, useState } from "react"
import { useModel } from "@umijs/max"
import { appList } from "@/services/distributor/appList"

const Page: React.FC = () => {
    let { state, getEnum } = useModel("global")
    let [key, setKey] = useState<any>(1)
    let getList = useAjax((params) => appList(params), { type: 'table' })
    return <PageContainer
        tabList={getEnum("APP_TYPE", "arr")}
        tabProps={{
            type: 'card',
            hideAdd: true,
            onChange: (e) => setKey(e),
        }}
    >
        <ProTable<any, any>
            headerTitle={"抖音小程序列表"}
            rowKey={(r) => r.id}
            search={{
                labelWidth: 120,
            }}
            scroll={{ x: "auto" }}
            params={{
                appType: key
            }}
            request={async (params) => {
                if (params.appType) {
                    return await getList.run(params)
                }
            }}
            columns={columns({ appType: key })}
            // expandable={{
            //     rowExpandable: (record) => record?.appCarrierList?.length > 0,
            //     expandRowByClick: true,
            //     expandedRowRender: (record) => {
            //         return <Table
            //             columns={childrenColumns}
            //             dataSource={record.appCarrierList}
            //             rowKey={(r) => r.id}
            //             pagination={false}
            //             size='small'
            //             bordered
            //         />
            //     },
            // }}
        />
    </PageContainer>

}
export default Page