import React, { useState, useImperativeHandle, forwardRef } from "react";
import { useModel } from "@umijs/max";
import { CompConfig } from "./compConfig";
import styles from './index.less'
import { useSize } from "ahooks";
// 定义组件的 Props 类型
interface Props {
    pageList: any[]
}

// 使用 forwardRef 以支持传递 ref
const SetData = forwardRef((props: Props, ref) => {
    let { pageList } = props
    const { state, dispatch } = useModel("appPageConifg")
    const size = useSize(document.querySelector(".ant-drawer-body"))
    // 使用 useImperativeHandle 暴露方法给父组件
    useImperativeHandle(ref, () => ({
    }));
    return <>
        <div className={styles.set} style={{ height: size?.height ? size.height - 50 : 'auto' }}>
            {state.compAc === 'banners' && <div> <CompConfig compName="banners" pageList={pageList} /></div>}
            {state.compAc === 'hot_books' && <div> <CompConfig compName="hot_books" /></div>}
            {state.compAc === 'hot_category' && <div> <CompConfig compName="hot_category" /></div>}
            {state.compAc === 'new_books' && <div> <CompConfig compName="new_books" /></div>}
            {state.compAc === 'hot_rec' && <div> <CompConfig compName="hot_rec" /></div>}
            {state.compAc === 'best_reviews' && <div> <CompConfig compName="best_reviews" /></div>}
            {state.compAc === 'classic_books' && <div> <CompConfig compName="classic_books" /></div>}
            {state.compAc === 'best_books' && <div> <CompConfig compName="best_books" /></div>}
            {!state.compAc && <div>选中组件可设置内容</div>}
        </div>
    </>
});

export default SetData;