import styles from './index.less'
import Header from "./header";
import { Empty, Space, Tag } from "antd";
import { ReactElement, JSXElementConstructor, ReactNode, ReactPortal, Key } from "react";
import { MyIcon } from "@/global";
import { RedoOutlined } from '@ant-design/icons';
// 必看好书
export function BestBooks(props: {
    data: {
        appComponentId: number | string;
        componentType: string;
        showRightButton?: boolean;
        componentName?: string;
        remark?: string;
        configs?: any[];
    }
}) {
    const { data: { configs, componentName, showRightButton } } = props
    return <div className={`${styles.hot_rec}`}>
        <Header title={componentName || "必看好书"} showBtn={showRightButton} element={<Space>换一换<RedoOutlined style={{color:'#f25d5d'}}/></Space>} />
        {configs?.[0]?.bookInfo ? <>
            <div className={styles.list}>
                {
                    configs?.map((item: { bookInfo: any }, index: Key | null | undefined) => {
                        return <div className={styles.top} key={index}>
                            <span>
                                {item?.bookInfo?.vipFree && <MyIcon type="icon-vipmianfei" style={{ fontSize: 35, position: 'absolute', zIndex: 1 }} />}
                                <img src={item?.bookInfo?.picUrl} onError={(e: any) => {
                                    e.target.src = localStorage.getItem("nocover")
                                }} />
                            </span>
                            <div>
                                <strong>{item?.bookInfo?.bookName || "书名"}</strong>
                                <span>{item?.bookInfo?.bookDesc || "描述"}</span>
                                <div>
                                    <span>{item?.bookInfo?.authorInfo?.authorName || item?.bookInfo?.authorName}·{item?.bookInfo?.wordCount}万字·{item?.bookInfo?.bookStatus == 0 ? "连载中" : "完结"}</span>
                                    <Tag >{item?.bookInfo?.labelInfoList?.[0]?.name}</Tag>
                                </div>
                            </div>
                        </div>
                    })
                }
            </div>
        </> : <div className={styles.banners_box} style={{ display: "flex", alignItems: 'center', justifyContent: 'center', minHeight: 'calc(100vw / 10)', }}>
            <div style={{ justifyContent: 'center', display: 'flex', width: '100%' }}><Empty image={Empty.PRESENTED_IMAGE_SIMPLE} description="暂无数据请选中后设置,不配置将使用系统默认配置" /></div>
        </div>
        }
    </div>
}

