import DownLoadImg from "@/components/DownLoadImg";
import { ProColumns } from "@ant-design/pro-components";
import { Popconfirm } from 'antd'
export const columns = (showNum?: boolean, offAuth?: (user: any) => void): ProColumns<any>[] => {
    return [
        {
            title: "企微名称",
            dataIndex: 'corpName',
            hideInSearch: true,
            align: "center",
        },
        {
            title: "客服名称",
            dataIndex: 'name',
            align: "center",
            hideInSearch: true,
        },

        {
            title: "客服ID",
            dataIndex: 'corpUserId',
            hideInSearch: true,
            align: "center",
        },
        {
            title: "当前用户数",
            dataIndex: 'customNum',
            align: "center",
            hideInSearch: true,
            hideInTable: !showNum
        },
        {
            title: "删除用户数",
            dataIndex: 'delCustomNum',
            hideInSearch: true,
            align: "center",
            hideInTable: !showNum
        },
        {
            title: "二维码",
            dataIndex: 'qrCode',
            hideInSearch: true,
            align: "center",
            hideInTable: !showNum,
            render: (_, row) => {
                return row.qrCode ? <DownLoadImg imgUrl={row.qrCode} style={{ width: 25 }} /> : "-"
            }
        },
        {
            title: "操作",
            dataIndex: 'cz',
            hideInSearch: true,
            align: "center",
            hideInTable: !showNum,
            render: (_, row) => {
                return <Popconfirm
                    title={<div>是否要取消<strong style={{ color: 'red' }}>{row?.name}</strong>的授权</div>}
                    onConfirm={() => { offAuth?.(row) }}
                >
                    <a >取消授权</a>
                </Popconfirm>
            }
        },
        // 搜索
        {
            title: "企微/客服名称",
            dataIndex: 'corpNameOrCorpUserName',
            hideInTable: true,
            align: "center",
            proFieldProps: {
                placeholder: "请输入企微/客服名称搜索",
            },
            formItemProps: {
                style: { width: 500 }
            }
        },
    ];
}