import { wechatScene } from "@/utils";
import { ProColumns } from "@ant-design/pro-components";

export const columns = (): ProColumns<any>[] => {
    return [
        {
            title: 'openId',
            dataIndex: 'openId',
            align: 'center',
            width: 70,
            ellipsis: true,
            render: (_, row) => {
                return row?.wechatMiniappUser?.openId
            }
        },
        {
            title: "小说名称",
            dataIndex: 'bookName',
            key: "bookName",
            align: "center",
            render: (a, b: any) => {
                return b?.bookInfo?.bookName
            }
        },
        {
            title: "章节名称",
            dataIndex: 'bookChapterName',
            key: "bookChapterName",
            hideInSearch: true,
            align: "center",
            render: (a, b) => {
                return b?.chapterInfo?.chapterName
            }
        },
        {
            title: "阅读场景",
            dataIndex: 'readCondition',
            key: "readCondition",
            align: "center",
            render:(_,row)=>{
                return wechatScene[row.readCondition]?.replace(/（.*/ig,'')
            }
        },
        {
            title: "阅读时间",
            dataIndex: 'createTime',
            key: "createTime",
            align: "center",
        },
        // 搜索条件
        {
            title: "开始时间",
            dataIndex: 'startTime',
            valueType: 'dateTime',
            hideInTable: true
        },
        {
            title: "结束时间",
            dataIndex: 'endTime',
            valueType: 'dateTime',
            hideInTable: true
        },
    ];
}