import { api } from '@/services/api';
import { request } from '@umijs/max';
type Page = {
  pageSize: number | string,
  pageNum: number | string
}

interface Params extends Page {
  corpId?: string,//企微ID
  corpName?: string,//企微名称
}
/**获取分销商账号列表 */
export async function corpListOfPage(params: Params) {
  return request(api + '/admin/corp/listOfPage', {
    method: 'GET',
    params
  });
}
/**授权 */
export async function corpPreAuth() {
  return request(api + '/admin/corp/preAuth', {
    method: 'GET',
  });
}

/**同步*/
export async function corpSyncAll(corpId:any) {
  return request(api + `/admin/corp/syncAll/${corpId}`, {
    method: 'PUT',
  });
}

//=========================================企微客服管理==========================
/**获取分销商账号列表 */
export async function corpUserListOfPage(params: Params) {
  return request(api + '/admin/corpUser/listOfPage', {
    method: 'GET',
    params
  });
}
/**批量指派 */
export async function corpUserConfigUser(data:{
  corpId:string,//企微ID
  corpUserIds:any[],//用户
  distributorAccountId:number,//分销商账号
}) {
  return request(api + '/admin/corpUser/configUser', {
    method: 'PUT',
    data
  });
}

/**同步*/
export async function corpUserSyncAll(corpId:any) {
  return request(api + `/admin/corpUser/syncAll/${corpId}`, {
    method: 'PUT',
  });
}