import { api } from '@/services/api';
import { request } from '@umijs/max';
type Page = {
    pageSize: number | string,
    pageNum: number | string
}
interface PublicParams {
    appId: string,//微信小程序组件ID
  }
export interface Params extends Page,PublicParams {
    openId?:string,//小程序用户标识
    unionId?:string,//联合ID
    userStanding?:string,//用户身份（NONE：普通用户、VIP：vip用户）
    coinNumMin?:string,//用户书币数量
    lastLoginTimeMin?:string,//最小登录时间
    lastLoginTimeMax?:string,//最大登录时间
    enabled?:boolean,//状态
}
/**微信小程序用户状态更新 */
export async function wechatMiniappUserUpdateEnabled(params: {
    id: string,
    enabled: boolean,//状态
}) {
    let { id, enabled } = params
    return request(api + `/admin/wechatMiniappUser/updateEnabled/${id}`, {
        method: 'PUT',
        data: { enabled }
    });
}
/**微信小程序用户列表 */
export async function wechatMiniappUserListOfPage(params: Params) {
    return request(api + '/admin/wechatMiniappUser/listOfPage', {
        method: 'GET',
        params
    })
}
/**删除微信小程序用户 */
export async function wechatMiniappUserDel(id: string) {
    return request(api +`/admin/wechatMiniappUser/delById/${id}`, {
        method: 'DELETE',
    })
}